NetBSD/distrib/sets/maketars

249 lines
5.6 KiB
Bash
Executable File

#!/bin/sh
#
# $NetBSD: maketars,v 1.96 2023/06/10 16:08:41 lukem Exp $
#
# Make release tar files for some or all lists. Usage:
# maketars [-b] [-x] [-i installdir] [-a arch] [-m machine] [-s setsdir]
# [-M metalog] [-N etcdir] [-F setlistsdir] [-d destdir]
# [-t tardir] [-U] [setname ...]
#
# The default sets are "base comp debug dtb etc games gpufw man misc rescue tests text"
# The X sets are "xbase xcomp xdebug xetc xfont xserver"
#
# If '-i installdir' is given, copy the given sets to installdir
# (using pax -rw ...) instead of creating tar files.
# In this case, remove "etc", and "xetc" from the list of default sets.
#
prog="${0##*/}"
rundir="$(dirname "$0")" # ${0%/*} isn't good enough when there's no "/"
. "${rundir}/sets.subr"
# set defaults
lists=
tars="${RELEASEDIR}"
dest="${DESTDIR}"
metalog=
installdir=
etcdir=
setlistdir=
timestamp=
setfilesonly=false
quiet=false
preserve="-pe"
# mtree(8) keys to skip (exclude) in the generated /etc/mtree/sets.* files.
# Note: sets contain sha256 so that keyword is not listed here.
skipkeys=cksum,md5,rmd160,sha1,sha384,sha512,time
usage()
{
cat 1>&2 <<USAGE
Usage: ${prog} [-L base,x] [-b] [-x] [-i idir] [-a arch] [-m machine]
[-s setsdir] [-S] [-M metalog] [-N etcdir] [-F setlistdir]
[-d dest] [-t targetdir] [setname ...]
-L base,x Make specified lists
-b Make both netbsd and x11 lists
-x Only make x11 lists
[Default: make netbsd lists]
-i idir Install sets to idir instead of creating tar files
-a arch Set arch (e.g, m68k, mipseb, mipsel, powerpc) [${MACHINE_ARCH}]
-m machine Set machine (e.g, amiga, i386, macppc) [${MACHINE}]
-q Quiet operation
-s setsdir Directory to find sets [${setsdir}]
-F setlistdir output directory for generated set lists [${dest}/etc/mtree/]
-S Exit after creating set files ${dest}/etc/mtree/set.*
-M metalog metalog file
-N etcdir etc dir for metalog use [${dest}/etc]
-U do not preserve file permissions (with -i ..)
-d dest \${DESTDIR} [${dest}]
-t targetdir \${RELEASEDIR} [${tars}]
-T timestamp Timestamp to set for all the files in the tar.
[setname ...] Sets to build [${lists}]
USAGE
exit 1
}
msg()
{
$quiet || echo $*
}
# handle args
while getopts L:bxi:a:m:qs:F:SM:N:Ud:t:T: ch; do
case ${ch} in
L)
save_IFS="${IFS}"
IFS=,
for _list in ${OPTARG}; do
case $_list in
base) lists="${lists} ${nlists}" ;;
x) lists="${lists} ${xlists}" ;;
esac
done
IFS="${save_IFS}"
;;
# backward compat
b)
lists="${nlists} ${xlists}"
;;
x)
lists="${xlists}"
;;
i)
installdir="${OPTARG}"
;;
a)
MACHINE_ARCH="${OPTARG}"
MACHINE_CPU="$(arch_to_cpu "${OPTARG}")"
;;
m)
MACHINE="${OPTARG}"
;;
q)
quiet=true
;;
s)
setsdir="${OPTARG}"
;;
F)
setlistdir="${OPTARG}"
;;
S)
setfilesonly=true
;;
M)
metalog="${OPTARG}"
;;
N)
etcdir="${OPTARG}"
;;
U)
preserve=
;;
d)
dest="${OPTARG}"
;;
t)
tars="${OPTARG}"
;;
T)
timestamp="--timestamp $OPTARG"
;;
*)
usage
;;
esac
done
shift $((${OPTIND} - 1))
if [ -n "${installdir}" ]; then # if -i, remove etc + xetc from the default list
lists="$(echo ${lists} | ${SED} -e 's/ etc / /;s/ xetc / /;')"
fi
if [ -n "$*" ]; then
lists="$*"
fi
if [ -z "${tars}" -a -z "${installdir}" ]; then
echo >&2 "${prog}: \${RELEASEDIR} must be set, or -i must be used"
exit 1
fi
if [ -z "${dest}" ]; then
echo >&2 "${prog}: \${DESTDIR} must be set"
exit 1
fi
: ${etcdir:="${dest}/etc"}
SDIR="$(${MKTEMP} -d "/tmp/${prog}.XXXXXX")"
TMPFILES=
: ${setlistdir:="${dest}/etc/mtree"}
cleanup()
{
es=$?
rm -rf "${SDIR}" ${TMPFILES}
trap - 0
exit ${es}
}
trap cleanup 0 2 3 13 # EXIT INT QUIT PIPE
#
# build the setfiles
#
for setname in ${lists}; do
msg "Creating flist.${setname}"
${HOST_SH} "${setsdir}/makeflist" -a "${MACHINE_ARCH}" -m "${MACHINE}" \
-s "${setsdir}" "${setname}" > "${SDIR}/flist.${setname}" \
|| exit 1
if [ ! -s "${SDIR}/flist.${setname}" ]; then
echo >&2 "makeflist output is empty for ${setname}"
exit 1
fi
msg "Creating set.${setname}"
if [ -n "${metalog}" ]; then
${AWK} -f "${rundir}/getdirs.awk" "${SDIR}/flist.${setname}" \
> "${SDIR}/flist.${setname}.full" \
|| exit 1
(
echo "/set uname=root gname=wheel"
${AWK} -f "${rundir}/join.awk" \
"${SDIR}/flist.${setname}.full" "${metalog}"
echo "./etc/mtree/set.${setname} type=file mode=0444"
) | ${MTREE} -CS -k all -R "${skipkeys}" -N "${etcdir}" \
> "${setlistdir}/set.${setname}" \
|| exit 1
# We deliberately do not add set.${setname} to ${metalog},
# because we depend on it as an input.
else
${MTREE} -c -p "${dest}" -k all -R "${skipkeys}" \
-N "${etcdir}" -O "${SDIR}/flist.${setname}" \
| ${MTREE} -C -k all -N "${etcdir}" \
> "${setlistdir}/set.${setname}"
fi
done
if ${setfilesonly}; then # exit after creating the set lists
exit 0
fi
runpax() {
local s="$1"
shift
(cd "${dest}" &&
${PAX} -dOw ${timestamp} -N"${etcdir}" -M "$@" < "${setlistdir}/set.${s}")
}
#
# now build the tarfiles
#
GZIP=-9n # for pax -z
export GZIP
es=0
for setname in ${lists:-${nlists}}; do
out="${setname}.${TAR_SUFF:-tgz}"
if [ -n "${installdir}" ]; then
msg "Copying set ${setname}"
runpax "${setname}" -r ${preserve} "${installdir}"
else
if [ -n "${metalog}" -a "${tars}/${out}" -nt "${metalog}" ]
then
msg "${out} is up to date"
continue
fi
msg "Creating ${out}"
rm -f "${tars}/${out}"
TMPFILES="${TMPFILES} ${tars}/${out}.tmp"
runpax "${setname}" -z --use-compress-program \
${COMPRESS_PROGRAM} > "${tars}/${out}.tmp" &&
mv "${tars}/${out}.tmp" "${tars}/${out}"
fi
es=$((${es} + $?))
done
if [ ${es} -gt 255 ]; then
es=255
fi
exit ${es}